//~~ john-mpi.hh ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  Items common to everything.
 *
 * @author   Wilson Chen   <wilson@cs.ucsb.edu>
 * @author   Brent Hall    <brendon@engineering.ucsb.edu>
 * @author   Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2004/06/03 14:33:10 $   $Revision: 1.7 $
 * @requires:   
 */

//==[ Identity ]================================================================

#ifndef  __JOHN_MPI_HH__
#define  __JOHN_MPI_HH__

#ifdef __JOHN_MPI_CC__
static char* hdrIdentity =
    "$Id: john-mpi.hh,v 1.7 2004/06/03 14:33:10 pippin Exp $";
#endif


//==[ Includes ]================================================================

#include  <stdio.h>
#include  <sys/time.h>


//==[ Typedefs/Structures/Enums ]===============================================

//==[ Constants ]===============================================================

namespace  john_mpi
{
    /**  Default verbose level. */
    extern int const    DEFAULT_verboseLevel;

    /**  Default invocation name. */
    extern char* const  DEFAULT_cmdName;

    /**  Default verbosity.  */
    extern int const    DEFAULT_Verbosity;

    /**  Default maximum number of passwords per message.  */
    extern int const    DEFAULT_MaxPasswords;

    /**  Default wordlist filename.  */
    extern char* const  DEFAULT_WordlistFilename;

    /**  Default password (input) file.  */
    extern char* const  DEFAULT_PasswordFilename;

    /**  Default results (output) file.  */
    extern char* const  DEFAULT_ResultsFilename;

    /**  Default password file (for workers).  */
    extern char* const  DEFAULT_CrackPasswd;

    /**  Default record dealer wait time.  */
    extern bool  const  DEFAULT_DealerWaitTime;
};


//==[ Variables ]===============================================================

namespace  john_mpi
{
    /**  Current verbose level. */
    extern int    verboseLevel;

    /**  Current invocation name. */
    extern char*  cmdName;

    /**  Current password file.  */
    extern char   passwdFile[ FILENAME_MAX ];

    /**  Recording dealer wait time?  */
    extern bool   dealerWaitTime;

    /**  Total dealer wait time.  */
    extern struct timeval  totalDealerWaitTime;
};


//==[ Classes ]=================================================================

//==[ Prototypes ]==============================================================

//------------------------------------------------------------------------------
/**
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#endif // __JOHN_MPI_HH__
