//~~ usage.hh ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  Describe usage.
 *
 * @author:    Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2004/05/30 00:58:21 $   $Revision: 1.2 $
 * @requires:   
 */

//==[ Identity ]================================================================

#ifndef  __USAGE_HH__
#define  __USAGE_HH__

#ifdef __USAGE_CC__
static char* hdrIdentity =
    "$Id: usage.hh,v 1.2 2004/05/30 00:58:21 pippin Exp $";
#endif


//==[ Includes ]================================================================

#include  <stdio.h>


//==[ Typedefs/Structures/Enums ]===============================================

//==[ Constants ]===============================================================

//==[ Variables ]===============================================================

//==[ Classes ]=================================================================

//==[ Prototypes ]==============================================================


namespace  Usage
{
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    /**
     *  Display correct usage (synopsis) of the application.
     *
     * @param   prefix       What to put before each line (NULL --> nothing).
     * @param   programName  Application name (NULL --> default).
     * @param   outStream    Stream to display output (NULL --> stdout).
     */
	    extern void
    print(
	char*	prefix =NULL,
	char*	programName =NULL,
	FILE*	outStream =NULL
    );


    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    /**
     *  Display complete description of the options.
     *
     * @param   helpTopic    Topic of interest (NULL --> all).
     * @param   programName  Application name (NULL --> default).
     * @param   prefix       What to put before each line (NULL --> nothing).
     * @param   outStream    Stream to display output (NULL --> stdout).
     */
	    extern void
    help(
	char*	helpTopic =NULL,
	char*	programName =NULL,
	char*	prefix =NULL,
	FILE*	outStream =NULL
    );


};



//==============================================================================
#endif // __USAGE_HH__
