//~~ worker.cc ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  description
 *
 * @author:    Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2004/05/16 23:04:04 $   $Revision: 1.2 $
 * @requires:   
 */


//==[ Identity ]================================================================

#define  __WORKER_CC__
static char* srcIdentity = 
    "$Id: worker.cc,v 1.2 2004/05/16 23:04:04 pippin Exp $";


//==[ Includes ]================================================================

#include  "mpi.h"

#include  "john-mpi.hh"
#include  "worker.hh"


//==[ Typedefs/Structures/Enums ]===============================================

//==[ Constants ]===============================================================

//==[ Variables ]===============================================================

//==[ Classes ]=================================================================

//==[ Prototypes ]==============================================================

//------------------------------------------------------------------------------
/*
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */


//==[ Implementation ]==========================================================

	void
Worker::Initialize(
    void
){
    myRank     = MPI::COMM_WORLD.Get_rank();
    numWorkers = MPI::COMM_WORLD.Get_size() -1;

    return;
}


//------------------------------------------------------------------------------

Worker::Worker(
    void
){
    Initialize();
    return;
}


//------------------------------------------------------------------------------

Worker::~Worker(
    void
){
}


//------------------------------------------------------------------------------

	int
Worker::start(
    void
){
    int  exitCode = 0;

    if( 1 < john_mpi::verboseLevel )
	printf( "Hello from the Worker %d (of %d)\n", myRank, numWorkers );

    if( 1 < john_mpi::verboseLevel )
	printf( "Goodbye from the Worker %d\n", myRank );

    return( exitCode );
}


//------------------------------------------------------------------------------

	int
Worker::crackPassword(
    WorkMsg*  workMsg
){
    // Does nothing.
    return( 0 );
}


//~~ Getters ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int Worker::getMyRank( void )
    { return( this->myRank ); }

int Worker::getNumWorkers( void )
    { return( this->numWorkers ); }


//------------------------------------------------------------------------------

	char*
Worker::toString(
    char*  prefix,
    char*  label
){
    static std::string  result;
    static char  line[ 256 ];

    // Initialize and fix NULLs.
    //
    result.erase();
    if( NULL == prefix )  prefix = "";
    if( NULL == label  )  label  = "Worker";

    snprintf( line, sizeof(line), "%s<%s>\n", prefix, label );
    result += line;

    snprintf( line, sizeof(line), "%s  <MyRank>%d</MyRank>\n",
						    prefix, myRank );
    result += line;

    snprintf( line, sizeof(line), "%s  <NumWorkers>%d</NumWorkers>\n",
						    prefix, numWorkers );
    result += line;

    snprintf( line, sizeof(line), "%s</%s>\n", prefix, label );
    result += line;

    return( (char*)result.c_str() );
}


//------------------------------------------------------------------------------

	bool
Worker::test(
    void
){
    bool  success =false;

    success = true;
EndWorkerTest:

    if( 0 < john_mpi::verboseLevel )
    {
	if( success )
	    printf( "Test was successful!\n" );
	else
	    printf( "Test Failed! :(\n" );
    }

    return( success );
}

//==============================================================================
