//~~ crack.hh ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  There are already too many files beginning with "john" and "work", so
 *  I called this "crack.cc"
 *
 * @author:    Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2004/05/31 19:17:39 $   $Revision: 1.3 $
 * @requires:   
 */

//==[ Identity ]================================================================

#ifndef  __CRACK_H__
#define  __CRACK_H__

#ifdef __CRACK_CC__
static char* hdrIdentity =
    "$Id: crack.hh,v 1.3 2004/05/31 19:17:39 pippin Exp $";
#endif


//==[ Includes ]================================================================

#include  <string>

#include  "worker.hh"


//==[ Typedefs/Structures/Enums ]===============================================

//==[ Constants ]===============================================================

//==[ Variables ]===============================================================

//==[ Classes ]=================================================================

class Crack : public Worker
{
  public: //====================================================================

    //~ Member Typedefs/Structures/Enums ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    //~ Member Constants ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


    //----------------------------------------------------------------------
    /**
     *  Create an instance with no arguments.
     */
    Crack(
        void
    );


    //----------------------------------------------------------------------
    /**
     *  Create an instance with the specified wordlist file.
     *
     * @param   wordlistFilename   Name of the wordlist file.
     */
    Crack(
        char*  wordlistFilename
    );


    //----------------------------------------------------------------------
    /**
     *  Default destructor.
     */
    	    virtual
    ~Crack(
        void
    );


    //~~ Getters ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

            virtual char*
    getWordlistFilename( void );


    //~~ Setters ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

            virtual void
    setWordlistFilename( char* wordlistFilename );


    //----------------------------------------------------------------------
    /**
     *  Attempt to break the password.
     *
     * @param   workMsg  Passwords to crack.
     * @return  Number of passwords cracked (negative number on error).
     */
            virtual int
    crackPassword(
	WorkMsg*  workMsg
    );


    //----------------------------------------------------------------------
    /**
     *  Begin execution.
     *
     * @return   Exit code (0 -=> no errors).
     */
    virtual int  start(
	void
    );


    //----------------------------------------------------------------------
    /**
     *  Make a string representation out of the instance.
     *
     * @param   prefix  Prepend this to each line (NULL --> "").
     * @param   label   Top-level label (NULL --> Worker).
     * @return  XML representation.
     */
            virtual char*
    toString(
	char*  prefix =NULL,
	char*  label  =NULL
    );


  protected: //===============================================================

  private: //=================================================================

    //~~ Member variables ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    int    stdError;		// File descriptor for standard error.
    char*  wordlistFilename;	// Name of the word file.


    //----------------------------------------------------------------------
    /**
     *  Initialize the member variables.
     */
    	    virtual void
    Initialize(
        void
    );

};


//==[ Prototypes ]==============================================================

//------------------------------------------------------------------------------
/**
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#endif // __WORKER_H__
